> ## Documentation Index
> Fetch the complete documentation index at: https://docs.roark.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get widget data

> Runs one widget and returns its series, as it reads on its dashboard (the dashboard's window and filters). Accepts the same `from` / `to` / `timezone` overrides as GET /v1/dashboard/{dashboardId}/data.



## OpenAPI

````yaml /api-reference/openapi.documented.json get /v1/dashboard/{dashboardId}/widget/{widgetId}/data
openapi: 3.1.0
info:
  title: Roark Analytics API
  description: >-
    The Roark Analytics API gives you access to the same API that powers the
    award winning Roark Analytics platform.
  version: 1.0.0
servers:
  - description: Production
    url: https://api.roark.ai
security:
  - Bearer: []
tags:
  - name: Agent
  - name: Agent Endpoint
  - name: Call
  - name: Chat
  - name: Metric
  - name: Metric Policy
  - name: Metric Collection Job
  - name: Customer Flow
  - name: Customer Flow Edge Case
  - name: Simulation
  - name: Simulation Persona
  - name: Simulation Environment
  - name: Simulation Scenario
  - name: Simulation Run Plan
  - name: Simulation Template
  - name: Simulation Run Plan Job
  - name: Simulation Job
  - name: HTTP Request Definition
  - name: Webhook
  - name: Issue
  - name: Autoimprove
  - name: Agent Config
  - name: Knowledge Base
  - name: Config
  - name: Organization Project
  - name: Organization Project Member
  - name: Organization Project API Key
  - name: Organization Config
  - name: CLI Auth
  - name: Me
  - name: Project
  - name: Usage
  - name: Analytics
  - name: Dashboard
  - name: Benchmark
  - name: Health
  - name: Prospect Simulation
paths:
  /v1/dashboard/{dashboardId}/widget/{widgetId}/data:
    get:
      tags:
        - Dashboard
      summary: Get widget data
      description: >-
        Runs one widget and returns its series, as it reads on its dashboard
        (the dashboard's window and filters). Accepts the same `from` / `to` /
        `timezone` overrides as GET /v1/dashboard/{dashboardId}/data.
      operationId: getV1DashboardByDashboardIdWidgetByWidgetIdData
      parameters:
        - in: query
          name: from
          schema:
            type: string
            format: date-time
            description: >-
              ISO 8601 start. Overrides the saved window; without `to`, runs
              until now.
        - in: query
          name: to
          schema:
            type: string
            format: date-time
            description: ISO 8601 end. Requires `from`.
        - in: query
          name: timezone
          schema:
            type: string
            minLength: 1
            description: IANA zone buckets and calendar periods align to. Default UTC.
        - schema:
            type: string
          in: path
          name: dashboardId
          required: true
        - schema:
            type: string
          in: path
          name: widgetId
          required: true
      responses:
        '200':
          description: The widget's data
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/DashboardWidgetData'
                required:
                  - data
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Validation error
              example:
                type: validation
                code: invalid_parameter
                message: The request was invalid
                param: email
          description: Bad Request
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Authentication error
              example:
                type: authentication
                code: unauthorized
                message: Authentication required
          description: Unauthorized
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Permission error
              example:
                type: forbidden
                code: permission_denied
                message: You do not have permission to access this resource
          description: Forbidden
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Not found error
              example:
                type: not_found
                code: resource_not_found
                message: The requested resource could not be found
          description: Dashboard or widget not found
        '429':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Rate limit error
              example:
                type: rate_limit
                code: too_many_requests
                message: Rate limit exceeded
          description: Too Many Requests
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Server error
              example:
                type: internal
                code: internal_error
                message: Internal server error
          description: Internal Server Error
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Roark from '@roarkanalytics/sdk';


            const client = new Roark({
              bearerToken: process.env['ROARK_API_BEARER_TOKEN'], // This is the default and can be omitted
            });


            const response = await client.dashboard.getWidgetData('widgetId', {
            dashboardId: 'dashboardId' });


            console.log(response.data);
        - lang: Python
          source: |-
            import os
            from roark_analytics import Roark

            client = Roark(
                bearer_token=os.environ.get("ROARK_API_BEARER_TOKEN"),  # This is the default and can be omitted
            )
            response = client.dashboard.get_widget_data(
                widget_id="widgetId",
                dashboard_id="dashboardId",
            )
            print(response.data)
components:
  schemas:
    DashboardWidgetData:
      type: object
      properties:
        widgetId:
          type: string
          format: uuid
        name:
          type: string
        interval:
          type: string
          enum:
            - HOUR
            - DAY
            - WEEK
            - MONTH
        blocked:
          type: boolean
        error:
          type:
            - string
            - 'null'
        series:
          type: array
          items:
            type: object
            properties:
              measureIndex:
                type: integer
              type:
                type: string
                enum:
                  - METRIC
                  - CONVERSATION
                  - UPTIME
              metric:
                type:
                  - string
                  - 'null'
              aggregation:
                type: string
                enum:
                  - COUNT
                  - AVG
                  - MIN
                  - MAX
                  - SUM
                  - MEDIAN
                  - PERCENTILE
                  - PASS_RATE
              breakdownValue:
                type:
                  - string
                  - 'null'
              comparisonGroup:
                type:
                  - string
                  - 'null'
              value:
                type: number
              sampleSize:
                type:
                  - number
                  - 'null'
              comparisonValue:
                type:
                  - number
                  - 'null'
              percentageOfBaseline:
                type:
                  - number
                  - 'null'
              buckets:
                type: array
                items:
                  type: object
                  properties:
                    date:
                      type: string
                    value:
                      type: number
                    passed:
                      type: number
                    sampleSize:
                      type: number
                    comparisonDate:
                      type: string
                    comparisonValue:
                      type: number
                    percentageOfBaseline:
                      type: number
                  required:
                    - date
                    - value
            required:
              - measureIndex
              - type
              - metric
              - aggregation
              - breakdownValue
              - comparisonGroup
              - value
              - sampleSize
              - comparisonValue
              - percentageOfBaseline
              - buckets
        omittedSeries:
          type: integer
        from:
          type: string
        to:
          type: string
        timezone:
          type: string
      required:
        - widgetId
        - name
        - interval
        - blocked
        - error
        - series
        - omittedSeries
        - from
        - to
        - timezone
    ErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - validation
            - authentication
            - forbidden
            - not_found
            - conflict
            - payment_required
            - rate_limit
            - internal
          description: The error type category
          examples:
            - validation
            - authentication
        code:
          type: string
          description: Machine-readable error code identifier
          examples:
            - invalid_parameter
            - missing_required_field
            - unauthorized
        message:
          type: string
          description: Human-readable error message
          examples:
            - The request was invalid
            - Authentication required
        param:
          type: string
          description: The parameter that caused the error (if applicable)
          examples:
            - email
            - user_id
        details:
          description: Additional error context information
      required:
        - type
        - code
        - message
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer
      bearerFormat: JWT

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.